#############################################################################################
##################  KOMAM - cvien - Statistika ve He o trny ############################
################### Katedra aplikovan matematiky, FEI, VB-TUO #############################

# Zdroj dat: https://www.kaggle.com/mylesoneill/game-of-thrones
# Npl cvien je inspirovna online kurzy na https://www.datacamp.com/

# Data jsou uloena v souboru GOT_Data.RData (lze nast dvojklikem na dan soubor nebo v okn Environment).

#############################################################################################
###################### 1. st - knihovna dplyr - prce s daty ##############################
#############################################################################################
library(dplyr)

#########################################################################################
# Funkce select - vybr poadovan promnn (sloupeky podle jejich nzvu nebo sla)
# Vbr nzv bitev z datov matice battles
select(battles, name)

# nebo pomoc pipovn
battles %>% select(name)

# Vbr vce promnnch, pomoc opertoru "%>%"
# Vyberme nap. promnn obsahujc nzev bitvy (name, 1. sloupec) a oblast (region, 12. sloupec)
battles %>% select(name,region)
# nebo
battles %>% select(1,12)

# Otzka: Jak jsou vhody a nevhody ve uvedench zpsob vbru sloupc?

# Opertor "%>%" se vyplat zejmna v ppad, kdy budeme rzn funkce kombinovat.

#########################################################################################
# Funkce filter - vybere pozorovn (dky) na zklad uveden podmnky
# Vyberme zznamy o bitvch, kter se odehrly v roce 299
filter(battles, year==299)
battles %>% filter(year==299)

# 1. kol - Vyberte takov bitvy, v nich toc armda mla vce ne 10 000 bojovnk.



# Ve funkci filter lze podmnky i kombinovat
# Vyberme nap. bitvy, v nich zvtzil toc krl Robb Stark.
battles %>% filter(attacker_king=="Robb Stark", attacker_outcome=="win")

# 2. kol - Vyberte bitvy typu "pitched battle", kter se odehrly v "The Riverlands".



# Funkce lze i "etzit", piem nm pijde vhod prv pipovn.
# Nap.: S vyuitm kdu z 2. kolu vyberme z datov matice battles pouze nzvy bitev 
# typu "pitched battle", kter se odehrly v "The Riverlands"
battles %>% 
  filter(region=="The Riverlands", battle_type=="pitched battle") %>% 
  select(name)

# Otzka: Zkusme obrtit poad - nejprve aplikujte funkci select a pot funkci filter, jak bude vstup?



# Znova se zamysleme nad operac "pipe" %>% !

# Takto "vyfiltrovan" nebo "vyselectovan" data si lze samozejm uloit pomoc "<-" nebo "="
# Nap.
nazvy_River_pitched <- battles %>% 
                        filter(region=="The Riverlands", battle_type=="pitched battle") %>% 
                        select(name)

#########################################################################################
# Funkce summarise - generuje sumrn statistiky (nap. prmr, medin, minimum, maximum,...)
# Zjistte prmrnou velikost toc armdy.
battles %>% summarise(mean(attacker_size, na.rm=T))

# Zvykem je tuto hodnotu njak i pojmenovat.
battles %>% summarise(prum_utok=mean(attacker_size, na.rm=T))

# 3. kol - Vyberte bitvy, ve kterch se krl Joffrey/Tommen Baratheon musel brnit 
# a vypotte prmrnou velikost tchto brncch se armd, 
# tento prmr nazvte prum_obrana_JTB.



# 4. kol - Doplte kd z 3. kolu o vpoet medinu velikosti brncch se armd,
# tuto hodnotu nazvte med_obrana_JTB.



# Otzka: Vzpomete si na pednku "Vad  nevad aneb statistika kolem ns".
# Co vypovd o promnn prmr a co vypovd medin?

# 5. kol - Zjistte kolik bojovnk mla nejvt armda krle jmnem Balon/Euron Greyjoy
# toc v bitvch, kter probhly v roce 299.



########################################################################################################
################# 2. st - knihovna ggplot2 - zklady pokroil grafiky :) ############################
library(ggplot2)

# Vykreslete nsledujc graf a prozkoumejte kd
ggplot(battles,aes(x=attacker_king))+
  geom_bar()

# Zkladn fungovn ggplot2 - pomoc vrstev:
# Nejprve definujeme "estetiku" (aesthetics)
#           - dleit st, kde specifikujeme promnnou na ose x a/nebo na ose y
#           - lze ale urit i promnnou, kter ovlivn velikost (size) nebo barvu (color) vykreslench objekt (nap. bod)
# Nsleduje uren "geometrie" (geometries)
#           - tato st definuje, jak se maj data znzornit
#           - jako body (geom_point), ry (geom_line), krabicov grafy (geom_boxplot), sloupcov grafy (geom_bar),...
#           - je teba uvit typ dat a na zklad toho, jakou chceme informaci pedat, zvolit geometrii
#           - rzn "geom" lze i kombinovat, m-li to smysl
# Dle je mon si hrt s mtky os (vzpomete si na pouit logaritmickho mtka) pomoc scale_x_log10() nebo scale_y_log10()
# Samozejmost je zmna popisk pomoc vrstvy "labels", grafick tmata (themes), apod.
# Knihovna ggplot2 um s grafy spoustu dalch skvlch vc, nicmn pro zatek nm toto posta.

# Pro zjemce doporuujeme: https://www.rstudio.com/wp-content/uploads/2015/03/ggplot2-cheatsheet.pdf

# sloupcov graf - poty bitev dle jmna tocho krle
ggplot(battles,aes(x=attacker_king))+
  geom_bar()

# logaritmick mtko aneb jak se kouzl s grafy
ggplot(battles,aes(x=attacker_king))+
  geom_bar()+
  scale_y_log10()

# 6. kol - Vytvote sloupcov graf prezentujc poty bitev dle jejich typu (battle_type)



# 7. kol - Upravte graf z 6. kolu tak, e na ose y pouijete logaritmick mtko.
# Porovnejte vsledek s pvodnm grafem z 6. kolu.



## Uvdomte si skal pouit logaritmickho mtka!

# 8. kol - Vyberte z datov matice battles pouze zznamy o bitvch, 
# kter se odehrly v roce 299. Tuto datovou sadu nazvte battles_299.
# Nsledn vykreslete sloupcov graf znzorujc poet bitev, 
# kter se odehrly v roce 299, dle jmen tocch krl (attacker_king).



# vimli jste si trochu rozdlnho "rozdlen" oproti hrnm potm? 
# Co takhle porovnat tato "rozdlen" nap roky?
ggplot(battles,aes(x=attacker_king))+
  geom_bar()+
  facet_wrap("year")


#############################################################
# Do te jsme se vnovali vizualizaci kategoriln promnn, pojme na numerickou.
# Vzpomeme si na krabicov graf, kter jste si ukazovali na pednce.
# Pro dal ely pracujme jen s tmi bitvami, ve kterch figuroval J/T Baratheon a Robb Stark.
# Tato data jsme pro vs nachystali a jsou rovn uloena v souboru GOT_Data.RData jako battles_subset.

# Vykreslme si krabicov graf (= boxplot) prezentujc velikosti brncch armd
ggplot(battles_subset,aes(x="",y=defender_size))+
  geom_boxplot()

# a tak vcensobn krabicov graf 
# pro velikosti brncch se armd v zvislosti na brncm krli
ggplot(battles_subset,aes(x=defender_king,y=defender_size))+
  geom_boxplot()

# Otzka: Co lze vyst z vykreslenho vcensobnho krabicovho grafu?

# 9. kol - V datov matici battles_subset najdete promnnou size_diff
# urujc rozdl ve velikosti toc a brnc armdy - 
# kladn hodnoty naznauj, e toc armda byla vt ne brnc.
# Vykreslete vcensobn krabicov graf znzorujc rozdl 
# ve velikosti armd podle vsledku bitvy. Jak vsledek oekvte?



# 10. kol - Oekvali jste obdren vsledek? Zejm ne...
# Pouijte funkce knihovny dplyr a vyberte jen na ty bitvy, 
# ve kterch byla toc armda men ne brnc.
# Podvejte se na typ bitvy a jej vsledek.



# 11. kol - Provete tot pro bitvy, v nich toc armda
# byla vt nebo stejn velk jako brnc armda.



# Otzka: Informace z kol 9-11 si dejte dohromady a pokuste se vysvtlit tento "jev".




